#pragma check_stack(off)
#include <stdlib.h>
#include <dos.h>
#include <memory.h>
#include <string.h>
#include <ctype.h>

#include "systypes.h"
#include "vsprintf.h"
#include "tsr.h"
#include "ems.h"
#include "debug.h"
#include "syscall.h"
#include "pport.h"
#include "xdr.h"
#include "rmount.h"


/*
 * Some cool define's
 */
#define FILE_NOT_FOUND		2
#define PATH_NOT_FOUND		3
#define ACCESS_DENIED 		5
#define NO_MORE_FILES	   18

#define	TRUE				1
#define	FALSE				0

#define	STACK_SIZE			1024
#define	FCARRY				0x0001
#define	MAX_FXN_NO			0x2E


char VolumeString[12];
char *TsrName = "RMOUNTE";
char *VersionString = "1.0";

/*
 * User data for tsr unloading mechanism
 */
typedef struct
{
	uint8 far *		our_int2f_handler;
	uint8 far *		prev_int2f_handler;
	uint32			our_drive_list;
	emshandle_t		emsCompression;
} user_data_t;

user_data_t		UserData;
uint16			emskeep = 0;

/*
 * Some compression data
 */
uint8			use_compress = 1;
emshandle_t		emsCompression=(emshandle_t) 0;
unsigned		segBuffer;
char far *		compBuffer;

SRCHREC			tempfind;
SRCHREC_PTR		ptempfind = (SRCHREC_PTR) & tempfind;


#define MK_STD_CMD(a,b,c,d) (((((uint32) a) & 0x000000FFul) <<  24) |\
							((((uint32) b) & 0x000000FFul) <<  16) |\
							((((uint32) c) & 0x000000FFul) <<  8) |\
							((((uint32) d) & 0x000000FFul)))

char *usage_string = "Usage:   rmount localdisk=remotedisk etc.\r\n\r\n"
	"Options:\r\n"
	"   DC  : Debug to console (this is the default)\r\n"
	"   DEx : Debug to ems, use x pages (defaults to 1)\r\n"
	"   Lx  : Debug level x (defaults to 0)\r\n"
	"   K   : Keep ems debug pages when unloading\r\n"
	"   SF  : Show list of debug flags\r\n"
	"   Px  : Use LPTx (defaults to 0)\r\n"
	"   CS  : Use smart compression (depending on file type)\r\n"
	"   CO  : Use no compression at all (default compression is on)\r\n"
	"   U   : Unload latest version\r\n"
	"\r\n";



INTVECT	prev_int2f_handler;

/*
 * Some globals that point to dos internal data structures
 */
char far*	cds_curpath;		/* ptr to current path in CDS */
uint8 far*	sda_ptr;			/* ptr to SDA */
char far*	sda_filename;		/* ptr to 1st filename area in SDA */
char far*	sda_filename2;		/* ptr to 2nd filename area in SDA */
char far*	sda_fcbname;		/* ptr to 1st FCB-style name in SDA */
uint8 far*	sda_srch_attr;		/* ptr to search attribute in SDA */
uint8 far*	sda_open_mode;		/* ptr to open mode in SDA */
SRCHREC_PTR	sda_srchrec;		/* ptr to 1st Search Data Block in SDA */
DIRREC_PTR	sda_dirrec;			/* ptr to 1st found dir entry area in SDA */
LOLREC_PTR	lolptr;				/* pointer to List Of Lists */

/* Other global data items */
ALL_REGS	GlobReg;			/* Global save area for all caller's regs */
char		our_drive_str[3] = " :";	/* Our drive letter string */
char far*	cds_path_root = "Remote_ :\\";	/* Root string for CDS */
uint16		cds_root_size;		/* Size of our CDS root string */
uint16		dos_ss;				/* DOS's saved SS at entry */
uint16		dos_sp;				/* DOS's saved SP at entry */
uint16		our_sp;				/* SP to switch to on entry */
uint16		save_sp;			/* SP saved across internal DOS calls */
int			filename_is_char_device;	/* generate_fcbname found character device name */
char		our_stack[STACK_SIZE];	/* our internal stack */
uint16 far*	stack_param_ptr;	/* ptr to word at top of stack on entry */
int			curr_fxn;			/* Record of function in progress */


/*
 * Some rmount global logic
 */
uint8		our_drive_no;		/* A: is 1, B: is 2, etc. */
uint8		rdrive;				/* A: is 1, B: is 2, etc. */
uint8		MountTable[26];		/* entry=0 ==> not mounted */

uint8		fxnmap[] = 
{
	_inquiry,				/* 0x00h */
	_rd,					/* 0x01h */
	_unsupported,			/* 0x02h */
	_md,					/* 0x03h */
	_shutdown,				/* 0x04h */
	_cd,					/* 0x05h */
	_closefile,				/* 0x06h */
	_commitfile,			/* 0x07h */
	_readfile,				/* 0x08h */
	_writefile,				/* 0x09h */
	_lockfile,				/* 0x0Ah */
	_unlockfile,			/* 0x0Bh */
	_diskspace,				/* 0x0Ch */
	_unsupported,			/* 0x0Dh */
	_setfileattr,			/* 0x0Eh */
	_getfileattr,			/* 0x0Fh */
	_unsupported,			/* 0x10h */
	_renamefile,			/* 0x11h */
	_unsupported,			/* 0x12h */
	_deletefile,			/* 0x13h */
	_unsupported,			/* 0x14h */
	_unsupported,			/* 0x15h */
	_openfile,				/* 0x16h */
	_createfile,			/* 0x17h */
	_unsupported,			/* 0x18h */
	_unsupported,			/* 0x19h */
	_unsupported,			/* 0x1Ah */
	_findfirst,				/* 0x1Bh */
	_findnext,				/* 0x1Ch */
	_unsupported,			/* 0x1Dh */
	_unsupported,			/* 0x1Eh */
	_unsupported,			/* 0x1Fh */
	_unsupported,			/* 0x20h */
	_seekfromend,			/* 0x21h */
	_unsupported,			/* 0x22h */
	_unsupported,			/* 0x23h */
	_unsupported,			/* 0x24h */
	_unsupported,			/* 0x25h */
	_unsupported,			/* 0x26h */
	_unsupported,			/* 0x27h */
	_unsupported,			/* 0x28h */
	_unsupported,			/* 0x29h */
	_unsupported,			/* 0x2Ah */
	_unsupported,			/* 0x2Bh */
	_unsupported,			/* 0x2Ch */
	_unknown_fxn_2D,		/* 0x2Dh */
	_specialopenfile		/* 0x2Eh */
};

void set_sft_owner(SFTREC_PTR sft)
	{
	_asm {
		push es
        push di
        les di, sft
        mov save_sp, sp     /* Save current stack pointer. */
        cli
        mov ss, dos_ss      /* Establish DOS's stack, current */
        mov sp, dos_sp      /* when we got called. */
        sti
        mov ax, 0x120c      /* Claim file as ours. */
        push ds             /* It needs DS to be DOS's DS, for DOS 5.0 */
        mov ds, GlobReg.ds
        int 0x2F
        pop bx              /* Restore DS */
        mov ds, bx          /* Restore SS (same as DS) */
        cli
        mov ss, bx
        mov sp, save_sp     /* and stack pointer (which we saved). */
        sti
        pop di
        pop es
    }
}

unsigned long dos_ftime(void)
	{
	_asm {
		mov save_sp, sp		/* Save current stack pointer. */
		cli
		mov ss, dos_ss		/* Establish DOS's stack, current */
		mov sp, dos_sp		/* when we got called. */
		sti
		mov ax, 0x120d		/* Get time/date. */
		push di				/* Subfunction 120C destroys di */
		push ds				/* It needs DS to be DOS's DS, for DOS 5.0 */
		push es
		mov es, GlobReg.es	
		mov di, GlobReg.di
		mov ds, GlobReg.ds	
		int 0x2F
		xchg ax,dx
		pop es
		pop ds				/* Restore DS */
		pop di
		mov bx, ds			/* Restore SS (same as DS) */
		cli
		mov ss, bx
		mov sp, save_sp		/* and stack pointer (which we saved). */
		sti
	}
}

// Does sda_fcbname point to a device name?
int is_a_character_device(uint16 dos_ds)
{
	_asm {
		mov ax, 0x1223		/* Search for device name. */
		push ds				/* It needs DS to be DOS's DS, for DOS 5.0 */
		mov ds, dos_ds
		int 0x2F
		pop ds				/* Restore DS */
		jnc is_indeed
	}
	return FALSE;
is_indeed:
	return TRUE;
	
}



/***************************************
 * Some frequently used service routines
 **************************************/

void init_sft(SFTREC_PTR p)
{
	/*
	 * Initialize the supplied SFT entry. Note the modifications to
	 * the open mode word in the SFT. If bit 15 is set when we receive
	 * it, it is an FCB open, and requires the Set FCB Owner internal
	 * DOS function to be called.
	 */
	if (p->open_mode & 0x8000)
			// File is being opened via FCB 
		p->open_mode |= 0x00F0;
	else
		p->open_mode &= 0x000F;

		// Mark file as being on network drive, unwritten to 
	p->dev_info_word = (unsigned) (0x8040 | (unsigned) our_drive_no);
	p->file_pos = 0;
	p->rel_sector = 0xffff;
	p->abs_sector = 0xffff;
	p->dev_drvr_ptr = 0;
			
	if(p->open_mode & 0x8000)
		set_sft_owner(p);
}

void fill_sft(SFTREC_PTR p, int use_found_1, int truncate, unsigned handle)
{
			/*
			 * we use the field start_sector to store the file handle which 
			 * is used by the server.
			 */
	_fmemcpy(p->file_name, sda_fcbname, 11);
	p->start_sector = handle;
	if (use_found_1)
	{
		p->file_attr = sda_dirrec->file_attr;
		p->file_time = truncate ? dos_ftime() : sda_dirrec->file_time;
		p->file_size = truncate ? 0L : sda_dirrec->file_size;
	}
	else
	{
		p->file_attr = (uint8) *stack_param_ptr;  /* Attr is top of stack */
		p->file_time = dos_ftime();
		p->file_size = 0;
	}
}


/* Fail, print message, exit to DOS */
void failprog(char * msg)
{
	tsr_print_string((uint8 far *) msg, TRUE);
	exit(1);
}

void get_fcbname_from_path(char far* path, char far* fcbname)
{
	int i;

	_fmemset(fcbname, ' ', 11);
	for (i = 0; *path; path++)
		if (*path == '.')
			i = 8;
		else
			fcbname[i++] = *path;
}


/*
 * Fail the current redirector call with the supplied error number, i.e.
 * set the carry flag in the returned flags, and set ax=error code
 */

void fail(uint16 err)
{
	GlobReg.flags=(GlobReg.flags | FCARRY);
	GlobReg.ax = err;
}

void succeed(void)
{
	GlobReg.flags=(GlobReg.flags & ~FCARRY);
	GlobReg.ax = 0;
}


/*
 * Deal with differences in DOS version once, and set up a set
 * of absolute pointers
 */

void set_up_pointers(void)
{
	cds_root_size = _fstrlen(cds_path_root);
	if (_osmajor==3)
	{
		sda_fcbname = ((V3_SDA_PTR) sda_ptr)->fcb_name;
		sda_filename = ((V3_SDA_PTR) sda_ptr)->file_name + cds_root_size - 1;
		sda_filename2 = ((V3_SDA_PTR) sda_ptr)->file_name_2 + cds_root_size - 1;
		sda_srchrec = &((V3_SDA_PTR) sda_ptr)->srchrec;
		sda_dirrec = &((V3_SDA_PTR) sda_ptr)->dirrec;
		sda_srch_attr = &((V3_SDA_PTR) sda_ptr)->srch_attr;
		sda_open_mode = &((V3_SDA_PTR) sda_ptr)->open_mode;
	}
	else
	{
		sda_fcbname = ((V4_SDA_PTR) sda_ptr)->fcb_name;
		sda_filename = ((V4_SDA_PTR) sda_ptr)->file_name + cds_root_size - 1;
		sda_filename2 = ((V4_SDA_PTR) sda_ptr)->file_name_2 + cds_root_size - 1;
		sda_srchrec = &((V4_SDA_PTR) sda_ptr)->srchrec;
		sda_dirrec = &((V4_SDA_PTR) sda_ptr)->dirrec;
		sda_srch_attr = &((V4_SDA_PTR) sda_ptr)->srch_attr;
		sda_open_mode = &((V4_SDA_PTR) sda_ptr)->open_mode;
	}
}



/*
 * This function should not be necessary. DOS usually generates an FCB
 * style name in the appropriate SDA area. However, in the case of
 * user input such as 'CD ..' or 'DIR ..' it leaves the fcb area all
 * spaces. So this function needs to be called every time. Its other
 * feature is that it uses an internal DOS call to determine whether
 * the filename is a DOS character device. We will 'Access deny' any
 * use of a char device explicitly directed to our drive
 */

void generate_fcbname(uint16 dos_ds)
{
	get_fcbname_from_path((char far*) (_fstrrchr(sda_filename, '\\') + 1),
		sda_fcbname);

	filename_is_char_device = is_a_character_device(dos_ds);
}


/*
 * Does the supplied string contain a wildcard '?'
 */
int contains_wildcards(char far* path)
{
	int i;
	
	for (i = 0; i < 11; i++)
		if (path[i] == '?')
			return TRUE;
	return FALSE;
}

/*
 * Get DOS version, address of Swappable DOS Area, and address of
 * DOS List of lists. We only run on versions of DOS >= 3.10, so
 * fail otherwise
 */

void get_dos_vars(void)
{
	uint16 segmnt;
	uint16 ofset;

	if ((_osmajor < 3) || ((_osmajor == 3) && (_osminor < 10)))
		failprog("Unsupported DOS Version");

	_asm {
		push ds
		push es
		mov ax, 5d06h;	/* Get SDA pointer */
		int 21h;
		mov segmnt, ds
		mov ofset, si
		pop es
		pop ds
	}
	sda_ptr = MK_FP(segmnt, ofset);

	_asm {
		push ds
		push es
		mov ax, 5200h;	/* Get Lol pointer */
		int 21h;
		mov segmnt, es
		mov ofset, bx
		pop es
		pop ds
		}
	lolptr = (LOLREC_PTR) MK_FP(segmnt, ofset);
}

/*
 * Determine if the call is for us and on which drive (our_drive_no)
 * the command takes place
 */
int is_call_for_us(uint16 es, uint16 di, uint16 ds)
{
	uint8 far * p;
	int 		ret = 0xFF;

	filename_is_char_device = 0;
	
		/* 
		 * Note that the first 'if' checks for the bottom 6 bits
		 * of the device information word in the SFT. Values > last drive
		 * relate to files not associated with drives, such as LAN Manager
		 * named pipes (Thanks to Dave Markun).
		 */
	if ((curr_fxn >= _closefile && curr_fxn <= _unlockfile)
		||	(curr_fxn == _seekfromend)
		||  (curr_fxn == _unknown_fxn_2D) )
	{
		our_drive_no=(((SFTREC_PTR) MK_FP(es,di))->dev_info_word & 0x3F);
		ret = (MountTable[our_drive_no] > 0);
	}
	else
	{
		if (curr_fxn ==_inquiry || curr_fxn==_shutdown)	// 2F/1100 -- succeed automatically
		{
			our_drive_no=0;
			ret = TRUE;
		}
		else
		{
			if (curr_fxn == _findnext)		// Find Next
			{
				SRCHREC_PTR psrchrec;	// check search record in SDA
				if (_osmajor==3)
					psrchrec=&(((V3_SDA_PTR) sda_ptr)->srchrec);
				else
					psrchrec=&(((V4_SDA_PTR) sda_ptr)->srchrec);
				our_drive_no= psrchrec->drive_no & 0x1F;
				return (int) ((psrchrec->drive_no & (uint8) 0x40) &&
					MountTable[our_drive_no]);
			}
			if (_osmajor==3)
				p=((V3_SDA_PTR) sda_ptr)->cdsptr;	// check CDS
			else
				p=((V4_SDA_PTR) sda_ptr)->cdsptr;

				/*
				 * Our drives are marked as "Remote_X:\" in which
				 * X is the local drive
				 */
			if (_fmemcmp(cds_path_root, p, cds_root_size-3) == 0)
			{
				our_drive_no=*(((uint8 far *)p) + cds_root_size-3)-'A';
				if (!MountTable[our_drive_no])
					return FALSE;

				if (curr_fxn != _diskspace)
					generate_fcbname(ds);
				return TRUE;
			}
			else
				return FALSE;
		}
	}
	return ret;
}


/*
 * Check to see that we are allowed to install
 */

int is_ok_to_load(void)
{
	_asm {
		mov ax, 1100h;
		int 2fh;
		cmp ax,1
		jne go_forward;
	}
	return 0;

go_forward:
	return 1;
}

is_local_free(uint8 drive)
{
	V3_CDS_PTR our_cds_ptr;

	our_cds_ptr = lolptr->cds_ptr;
	if (_osmajor == 3) 
		our_cds_ptr = our_cds_ptr + drive;
	else
	{
		V4_CDS_PTR t = (V4_CDS_PTR) our_cds_ptr;
		t = t + drive;
		our_cds_ptr = (V3_CDS_PTR) t;
	}

	if (drive >= lolptr->last_drive)
		return 0;

		/*
		 * Check that this drive letter is currently invalid (not in 
		 * use already)
		 * 0xc000 tests both physical and network bits at same time
		 */
	if ((our_cds_ptr->flags & 0xc000) != 0)
		return 0;

	return 1;
}
		
void make_net_drive(uint8 drive)
{
	V3_CDS_PTR our_cds_ptr;

	our_cds_ptr = lolptr->cds_ptr;
	if (_osmajor == 3) 
		our_cds_ptr = our_cds_ptr + drive;
	else
	{
		V4_CDS_PTR t = (V4_CDS_PTR) our_cds_ptr;
		t = t + drive;
		our_cds_ptr = (V3_CDS_PTR) t;
	}

		/*
		 * Set Network+Physical+NotRealNetworkDrive bits on, and
		 * establish our 'root'
		 * we mark the drive as Remote-X:\ with X the local drive
		 * this way we know on what drive we the got a request
		 */
	our_cds_ptr->flags |= 0xc080;
	cds_path_root[cds_root_size-3] = (char) ('A'+ drive);
	_fstrcpy(our_cds_ptr->current_path, cds_path_root);
	our_cds_ptr->root_ofs = cds_root_size - 1;
}

void free_net_drive(uint8 drive)
{
	V3_CDS_PTR our_cds_ptr;

	our_cds_ptr = lolptr->cds_ptr;
	if (_osmajor == 3) 
		our_cds_ptr = our_cds_ptr + drive;
	else
	{
		V4_CDS_PTR t = (V4_CDS_PTR) our_cds_ptr;
		t = t + drive;
		our_cds_ptr = (V3_CDS_PTR) t;
	}
		/*
		 * clear the netmask bits
		 */
	our_cds_ptr->flags=our_cds_ptr->flags & 0x3fff;
}


/*
 * Respond that it is OK to load another redirector
 */

void cmd_inquiry(void)				// subfunc 01
{
	GlobReg.ax = 0x00FF;
}

void cmd_findnext(void)				// subfunc 1C
{
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	unsigned	retval;

	dprintf(D_CLIENT,"%c: finding next...\n", our_drive_no+'A');
	if ((retval=sys_findnext(cmd, sda_srchrec, sda_dirrec)))
	{
		dprintf(D_CLIENT,"findnext failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	dprintf(D_CLIENT,"findnext succeeded, entry=%11fs, attr=0x%x, size=%lu\n", sda_dirrec->file_name, (unsigned) sda_dirrec->file_attr, sda_dirrec->file_size);

}

/*
 * FindFirst - subfunction 1Bh
 */

void cmd_findfirst(void)
{
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	unsigned	retval;

	dprintf(D_CLIENT,"%c: findfirst:%fs, mask=0x%x,d:0x%x\n", our_drive_no+'A', sda_filename, (unsigned) *sda_srch_attr, (unsigned) sda_srchrec->drive_no);
	if ((retval=sys_findfirst(cmd, sda_filename, *sda_srch_attr, sda_dirrec, sda_srchrec)))
	{
		dprintf(D_CLIENT,"findfirst failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}

	_fmemcpy(&sda_srchrec->srch_mask, sda_fcbname, 11);
	//sda_srchrec->dir_entry_no = 0;
	//sda_srchrec->attr_mask = sda_dirrec->file_attr;
	sda_srchrec->drive_no = (uint8) (our_drive_no | 0xC0);
	dprintf(D_CLIENT,"findfirst succeeded, entry=%11fs, attr=0x%x, size=%lu\n", sda_dirrec->file_name, (unsigned) sda_dirrec->file_attr, sda_dirrec->file_size);
}


void cmd_rmdir(void)
{
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT, "%c: rmdir:%fs\n", our_drive_no+'A', sda_filename);
	if ((retval=sys_rmdir(cmd, sda_filename)) !=0)
	{
		dprintf(D_CLIENT,"rmdir failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	dprintf(D_CLIENT, "rmdir succeeded\n");
}

void cmd_mkdir(void)
{
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT, "%c: mkdir:%fs\n", our_drive_no+'A', sda_filename);
	if ((retval=sys_mkdir(cmd, sda_filename)) !=0)
	{
		dprintf(D_CLIENT,"mkdir failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	dprintf(D_CLIENT,"mkdir succeeded\n");
}

void cmd_commitfile(void)
{
	SFTREC_PTR	p=(SFTREC_PTR) MK_FP(GlobReg.es, GlobReg.di);
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	uint16		retval;

	dprintf(D_CLIENT, "%c: commitfile:%fs, handle=0x%x\n", our_drive_no+'A', sda_filename, p->start_sector);
	if ((retval=sys_commitfile(cmd, p->start_sector)) !=0)
	{
		dprintf(D_CLIENT,"commitfile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	dprintf(D_CLIENT,"commitfile succeeded\n");
}

/*
 * Change Directory - subfunction 05h
 */

void cmd_cd(void)
{
	V3_CDS_PTR 	our_cds_ptr;
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT, "%c: chdir:%fs\n", our_drive_no+'A', sda_filename);
	if ((retval=sys_chdir(cmd, sda_filename)) !=0)
	{
		dprintf(D_CLIENT,"chdir failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}

	our_cds_ptr = lolptr->cds_ptr;
	if (_osmajor == 3) 
		our_cds_ptr = our_cds_ptr + our_drive_no;
	else
	{
		V4_CDS_PTR t = (V4_CDS_PTR) our_cds_ptr;
		t = t + our_drive_no;
		our_cds_ptr = (V3_CDS_PTR) t;
	}

	_fstrcpy(our_cds_ptr->current_path+cds_root_size-1, sda_filename);
	dprintf(D_CLIENT,"chdir succeeded\n");
}

void cmd_setfileattr(void)
{
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT, "%c: setfileattr:%fs, attr=0x%x\n", our_drive_no+'A', sda_filename, *stack_param_ptr);
	if ((retval=sys_setfileattr(cmd, sda_filename, *stack_param_ptr)) !=0)
	{
		dprintf(D_CLIENT,"setfileattr failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	dprintf(D_CLIENT,"setfileattr succeeded\n");
}

void cmd_writefile(void)
{
	SFTREC_PTR 	p = (SFTREC_PTR) MK_FP(GlobReg.es, GlobReg.di);
	uint32		cmd=MK_STD_CMD(0, use_compress, rdrive, curr_fxn);
	uint16		retval;
	uint16		v1,v2;

	dprintf(D_CLIENT,"%c: writefile:%fs, handle=0x%x, file_size=%lu, file_pos=%lu count=%u\n", our_drive_no+'A', p->file_name, p->start_sector, p->file_size, p->file_pos, GlobReg.cx);


	if (!(p->open_mode & 3))
	{
		dprintf(D_CLIENT,"writefile failed, not open for writing\n");
		fail(ACCESS_DENIED);
		return;
	}

	if (!GlobReg.cx)
		p->file_size=p->file_pos;
	//p->file_time=dos_ftime();
			// V3_SDA_PTR cast is save: current_dta has fixed offset in SDA
	 if ((retval=sys_writefile(cmd, p->start_sector, p->file_pos, p->file_time, GlobReg.cx, ((V3_SDA_PTR) sda_ptr)->current_dta, &GlobReg.cx)) !=0)
	{
		dprintf(D_CLIENT,"writefile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	p->file_pos+=GlobReg.cx;
	if (p->file_pos > p->file_size)
		p->file_size=p->file_pos;
	dprintf(D_CLIENT,"writefile succeeded, wrote %u bytes\n", GlobReg.cx);
}

void cmd_renfile(void)
{
	fail(FILE_NOT_FOUND);
/*
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT, "%c: renaming:%fs->%fs\n", our_drive_no+'A', sda_filename, sda_filename2);

	if ((retval=sys_renfile(cmd, sda_filename, sda_filename2)) !=0)
		fail(retval);
*/
}

void cmd_delfile(void)
{
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT, "%c: delfile:%fs\n", our_drive_no+'A', sda_filename);
	if ((retval=sys_delfile(cmd, sda_filename)) !=0)
	{
		dprintf(D_CLIENT,"delfile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	dprintf(D_CLIENT,"delfile succeeded\n");
}

void cmd_createfile(void)
{
	unsigned	retval, handle;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	uint32		cmd_ff=MK_STD_CMD(0, 0, rdrive, _findfirst);
	SFTREC_PTR 	p=(SFTREC_PTR) MK_FP(GlobReg.es, GlobReg.di);

	dprintf(D_CLIENT, "%c: createfile:%fs, attr=0x%x\n", our_drive_no+'A', sda_filename, (uint16) *stack_param_ptr);
	if (contains_wildcards(sda_fcbname))
	{
		dprintf(D_CLIENT,"createfile failed, filename contains wildcards\n");
		fail(PATH_NOT_FOUND);
		return;
	}
	
	*sda_srch_attr=0x3f;
	dprintf(D_CLIENT,"issuing a findfirst\n");
	retval=sys_findfirst(cmd_ff, sda_filename, *sda_srch_attr, sda_dirrec, ptempfind);
	if (retval && (retval != FILE_NOT_FOUND && retval != NO_MORE_FILES))
	{
		dprintf(D_CLIENT,"creatfile failed, error in findfirst\n");
		return;
	}
	dprintf(D_CLIENT,"findfirst done\n");

	if ((!retval) && (sda_dirrec->file_attr & 0x19))
	{
		dprintf(D_CLIENT,"createfile failed, cannot truncate\n");
		fail(ACCESS_DENIED);
		return;
	}

	if ((retval=sys_createfile(cmd, sda_filename, *stack_param_ptr, &handle)) !=0)
	{
		dprintf(D_CLIENT,"createfile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}

		
	fill_sft(p, (!GlobReg.ax), TRUE, handle);
	init_sft(p);
	succeed();
	dprintf(D_CLIENT,"createfile succeeded, handle=0x%x \n", handle);
}


/*
 * Close File - subfunction 06h
 */

void cmd_closefile(void)
{
	SFTREC_PTR 	p = (SFTREC_PTR) MK_FP(GlobReg.es, GlobReg.di);
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	unsigned	retval;

	dprintf(D_CLIENT,"%c: closefile:%fs, handle=0x%x\n", our_drive_no+'A', p->file_name, p->start_sector); 

	if ((retval=sys_closefile(cmd, p->start_sector)) !=0)
	{
		dprintf(D_CLIENT,"closefile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}

	if (p->handle_count)
		p->handle_count--;
	dprintf(D_CLIENT,"closefile succeeded\n");
}


/*
 * Read from File - subfunction 08h
 * For version that handles critical errors,
 * see Undocumented DOS, 2nd edition, chapter 8
 */

void cmd_readfile(void)
{
	SFTREC_PTR 	p = (SFTREC_PTR) MK_FP(GlobReg.es, GlobReg.di);
	uint32		cmd=MK_STD_CMD(0, use_compress, rdrive, curr_fxn);
	uint16		retval;

	dprintf(D_CLIENT,"%c: readfile:%fs, handle=0x%x, file_size=%lu, file_pos=%lu, count=%u\n", our_drive_no+'A', p->file_name, p->start_sector, p->file_size, p->file_pos, GlobReg.cx);

	if (p->open_mode & 1)
	{
		dprintf(D_CLIENT,"readfile failed, not open for reading\n");
		fail(ACCESS_DENIED);
		return;
	}
	
	if ((p->file_pos + GlobReg.cx) > p->file_size)
		GlobReg.cx = (uint16) (p->file_size - p->file_pos);

	if (! GlobReg.cx)
	{
		dprintf(D_CLIENT,"readfile succeeded (nothing to read)\n");
		return;
	}

			// V3_SDA_PTR cast is save: current_dta has fixed offset in SDA
	retval=sys_readfile(cmd, p->start_sector, p->file_pos, GlobReg.cx, ((V3_SDA_PTR) sda_ptr)->current_dta, &GlobReg.cx);
	if (retval)
	{
		dprintf(D_CLIENT,"readfile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}

	p->file_pos+=GlobReg.cx;
	dprintf(D_CLIENT,"readfile succeeded, read %u bytes\n", GlobReg.cx);
}


/*
 * Get Disk Space - subfunction 0Ch
 */

void cmd_diskspace(void)
{
	unsigned	retval;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT,"%c: diskspace\n", our_drive_no+'A');
	if ((retval=sys_getdiskspace(cmd, &GlobReg.ax, &GlobReg.bx, &GlobReg.cx, &GlobReg.dx)))
	{
		dprintf(D_CLIENT,"diskspace failed, error=0x%x\n", retval);
		GlobReg.ax = 0;
		GlobReg.bx = 0;
		GlobReg.cx = 0;
		GlobReg.dx = 0;
		return;
	}
	dprintf(D_CLIENT,"diskspace succeeded\n");
}

/*
 * Get File Attributes - subfunction 0Fh
 */

void cmd_getfileattr(void)
{
	unsigned	retval;
	unsigned	attr;
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_CLIENT,"%c: getfileattr:%fs\n", our_drive_no+'A', sda_filename);
	if ((retval=sys_getfileattr(cmd, sda_filename, &attr)) !=0)
	{
		dprintf(D_CLIENT,"getfileattr failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}

	GlobReg.ax=attr;
	dprintf(D_CLIENT,"getfileattr succeeded, attr=0x%x\n", attr);
}



/*
 * Open Existing File - we first issue a findfirst to obtain date, attrib
 * and filesize
 */

void cmd_openfile(void)
{
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	uint32		cmd_ff=MK_STD_CMD(0, 0, rdrive, _findfirst);
	uint16		handle, retval;
	uint8		open_mode=*sda_open_mode;
	SFTREC_PTR	p=(SFTREC_PTR) MK_FP(GlobReg.es, GlobReg.di);

	dprintf(D_CLIENT,"%c: openfile:%fs, mode=0x%x\n", our_drive_no+'A', sda_filename, (uint16) open_mode);
	
	if (contains_wildcards(sda_fcbname))
	{
		dprintf(D_CLIENT,"openfile failed, filename contains wildcards\n");
		fail(PATH_NOT_FOUND);
		return;
	}

	*sda_srch_attr=0x3f;
	dprintf(D_CLIENT,"issuing a findfirst\n");
	sys_findfirst(cmd_ff, sda_filename, *sda_srch_attr, sda_dirrec, ptempfind);
	dprintf(D_CLIENT,"findfirst done\n");

	if ((retval=sys_openfile(cmd, sda_filename, open_mode, &handle)) !=0)
	{
		dprintf(D_CLIENT,"openfile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
	fill_sft(p, TRUE, FALSE, handle);
	init_sft(p);
	succeed();
	dprintf(D_CLIENT,"openfile succeeded, handle=0x%x\n", handle);

}

/* Special Multi-Purpose Open File - subfunction 2Eh */

#define CREATE_IF_NOT_EXIST		0x10
#define OPEN_IF_EXISTS			0x01
#define REPLACE_IF_EXISTS		0x02

void cmd_special_openfile(void)
{
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);
	uint32		cmd_ff=MK_STD_CMD(0, 0, rdrive, _findfirst);
	SFTREC_PTR 	p = (SFTREC_PTR) MK_FP(GlobReg.es,GlobReg.di);
	uint16 		retval, open_mode, action, handle;

	//open_mode = ((V4_SDA_PTR) sda_ptr)->mode_2E & 0x7f;
	open_mode = ((V4_SDA_PTR) sda_ptr)->mode_2E;
	action = ((V4_SDA_PTR) sda_ptr)->action_2E;
	p->open_mode = open_mode;

	dprintf(D_CLIENT,"%c: special openfile:%fs, mode=0x%x, action=0x%x, attr=0x%x\n", our_drive_no+'A', sda_fcbname, open_mode, action, (uint16) *stack_param_ptr);

	if (contains_wildcards(sda_fcbname))
	{
		dprintf(D_CLIENT,"specialopenfile failed, filename contains wildcards\n");
		fail(PATH_NOT_FOUND);
		return;
	}

	*sda_srch_attr = 0x3f;
	dprintf(D_CLIENT,"issuing a findfirst\n");
	retval=sys_findfirst(cmd_ff, sda_filename, *sda_srch_attr, sda_dirrec, ptempfind);
	if (retval && !(retval != FILE_NOT_FOUND || retval != NO_MORE_FILES) )
	{
		dprintf(D_CLIENT,"specialopenfile failed, error in findfirst\n");
		return;
	}
	dprintf(D_CLIENT,"findfirst done\n");

	if ((retval=sys_special_openfile(cmd, sda_filename, *stack_param_ptr, open_mode, action, &GlobReg.cx, &handle)) !=0)
	{
		dprintf(D_CLIENT,"specialopenfile failed, error=0x%x\n", retval);
		fail(retval);
		return;
	}
		
	fill_sft(p, (!GlobReg.ax), action & REPLACE_IF_EXISTS, handle);
	init_sft(p);
	succeed();
	dprintf(D_CLIENT,"specialopenfile succeeded, result=0x%x, handle=0x%x\n", GlobReg.cx, handle);
}


/*
 * This function is never called! DOS fiddles with position internally
 */

void cmd_seekfromend(void)
{
/*
	int32 seek_amnt;
	SFTREC_PTR p;

	* But, just in case... *
	seek_amnt = -1L * (((int32) GlobReg.cx << 16) + GlobReg.dx);
	p = (SFTREC_PTR) MK_FP(GlobReg.es,GlobReg.di);
	if (seek_amnt > p->file_size)
		seek_amnt = p->file_size;
	
	p->file_pos = p->file_size - seek_amnt;
	GlobReg.dx = (uint16) (p->file_pos >> 16);
	GlobReg.ax = (uint16) (p->file_pos & 0xFFFF);
*/
}

void cmd_closeall(void)
{
	dprintf(D_CLIENT,"%c: closeall\n", our_drive_no+'A');
	dprintf(D_CLIENT,"Oops closeall not implemented yet\n");
}

void cmd_unknown_fxn_2D()
{
	dprintf(D_CLIENT,"%c unknown function_2D:%u\n", our_drive_no+'A', curr_fxn);
	GlobReg.ax = 2;
	/* Only called in v4.01, this is what MSCDEX returns */
}

void cmd_shutdown(void)
{
	uint32		cmd=MK_STD_CMD(0, 0, rdrive, curr_fxn);

	dprintf(D_SYSTEM, "Preparing shutdown....\n");
	xdr_uint32(XDR_WRITE, &cmd);
}

/*
 * A placeholder
 */

void cmd_unsupported(void)
{
	dprintf(D_CLIENT,"%c: unsupported function:%u\n", our_drive_no+'A', curr_fxn);
	return;
}

PROC dispatch_table[]=
{
	cmd_inquiry,				/* 0x00h */
	cmd_rmdir,					/* 0x01h */
	cmd_unsupported,			/* 0x02h */
	cmd_mkdir,					/* 0x03h */
	cmd_shutdown,				/* 0x04h */
	cmd_cd,						/* 0x05h */
	cmd_closefile,				/* 0x06h */
	cmd_commitfile,				/* 0x07h */
	cmd_readfile,				/* 0x08h */
	cmd_writefile,				/* 0x09h */
	cmd_unsupported,			/* 0x0Ah */
	cmd_unsupported,			/* 0x0Bh */
	cmd_diskspace,				/* 0x0Ch */
	cmd_unsupported,			/* 0x0Dh */
	cmd_setfileattr,			/* 0x0Eh */
	cmd_getfileattr,			/* 0x0Fh */
	cmd_unsupported,			/* 0x10h */
	cmd_renfile,				/* 0x11h */
	cmd_unsupported,			/* 0x12h */
	cmd_delfile,				/* 0x13h */
	cmd_unsupported,			/* 0x14h */
	cmd_unsupported,			/* 0x15h */
	cmd_openfile,				/* 0x16h */
	cmd_createfile,				/* 0x17h */
	cmd_unsupported,			/* 0x18h */
	cmd_unsupported,			/* 0x19h */
	cmd_unsupported,			/* 0x1Ah */
	cmd_findfirst,				/* 0x1Bh */
	cmd_findnext,				/* 0x1Ch */
	cmd_closeall,				/* 0x1Dh close all files for a process*/
	cmd_unsupported,			/* 0x1Eh */
	cmd_unsupported,			/* 0x1Fh */
	cmd_unsupported,			/* 0x20h */
	cmd_seekfromend,			/* 0x21h */
	cmd_unsupported,			/* 0x22h */
	cmd_unsupported,			/* 0x23h */
	cmd_unsupported,			/* 0x24h */
	cmd_unsupported,			/* 0x25h */
	cmd_unsupported,			/* 0x26h */
	cmd_unsupported,			/* 0x27h */
	cmd_unsupported,			/* 0x28h */
	cmd_unsupported,			/* 0x29h */
	cmd_unsupported,			/* 0x2Ah */
	cmd_unsupported,			/* 0x2Bh */
	cmd_unsupported,			/* 0x2Ch */
	cmd_unsupported,			/* 0x2Dh */
	cmd_special_openfile		/* 0x0Eh */
	};




/*
 * This is the main entry point for the redirector. It assesses if
 * the call is for our drive, and if so, calls the appropriate routine. On
 * return, it restores the (possibly modified) register values.
 */

void interrupt far redirector(ALL_REGS entry_regs)
{
	static uint16 save_bp;
	static uint16 StkPtr;
	
	_asm STI;

	if (((entry_regs.ax >> 8) != (uint8) 0x11) ||
		((uint8) entry_regs.ax > MAX_FXN_NO))
			goto chain_on;

	curr_fxn = fxnmap[(uint8) entry_regs.ax];

	if ((curr_fxn == _unsupported) ||
		(! is_call_for_us(entry_regs.es, entry_regs.di, entry_regs.ds)))
		goto chain_on;

	/* Set up our copy of the registers */
	GlobReg.ax=entry_regs.ax;
	GlobReg.bx=entry_regs.bx;
	GlobReg.cx=entry_regs.cx;
	GlobReg.dx=entry_regs.dx;
	GlobReg.es=entry_regs.es;
	GlobReg.ds=entry_regs.ds;
	GlobReg.bp=entry_regs.bp;
	GlobReg.sp=entry_regs.sp;
	GlobReg.si=entry_regs.si;
	GlobReg.di=entry_regs.di;
	GlobReg.ip=entry_regs.ip;
	GlobReg.cs=entry_regs.cs;
	GlobReg.flags=entry_regs.flags;
	
/*
 * AAAARRRGGGGHHH, somehow this struct copy causes a hang, donno why
 */
	//GlobReg=entry_regs;

		/* 
		 * Save ss:sp and switch to our internal stack. We also save bp
		 * so that we can get at any parameter at the top of the stack
		 * (such as the file attribute passed to subfxn 17h).
		 */

	_asm cli
	_asm mov dos_ss, ss;
	_asm mov save_bp, bp;
	_asm sti
	stack_param_ptr = (uint16 far*) MK_FP(dos_ss, save_bp + sizeof(ALL_REGS)); 
/*
 * Make sure the SP is an even address
 */

	StkPtr=(unsigned) our_stack + STACK_SIZE -2;
	if (StkPtr & 1u)
		StkPtr--;
	_asm {
		cli
		mov dos_sp, sp;
		mov ax, ds
		mov ss, ax			// New stack segment is in Data segment.
		//mov sp, offset our_stack + STACK_SIZE -2
		mov sp, StkPtr
		sti
	}

	// Expect success!
	succeed();
	
	// Call the appropriate handling function unless we already know we
	// need to fail
	if (filename_is_char_device)
		fail(ACCESS_DENIED);
	else
	{
		emsSaveMap();
		rdrive=MountTable[our_drive_no]-1;
		dispatch_table[curr_fxn]();
		emsRestoreMap();
	}

	// Switch the stack back
	_asm {
		cli;
		mov ss, dos_ss;
		mov sp, dos_sp;
		sti;
	}

	// put the possibly changed registers back on the stack, and return
	//entry_regs=GlobReg;
	entry_regs.ax=GlobReg.ax;
	entry_regs.bx=GlobReg.bx;
	entry_regs.cx=GlobReg.cx;
	entry_regs.dx=GlobReg.dx;
	entry_regs.es=GlobReg.es;
	entry_regs.ds=GlobReg.ds;
	entry_regs.bp=GlobReg.bp;
	entry_regs.sp=GlobReg.sp;
	entry_regs.si=GlobReg.si;
	entry_regs.di=GlobReg.di;
	entry_regs.ip=GlobReg.ip;
	entry_regs.cs=GlobReg.cs;
	entry_regs.flags=GlobReg.flags;
	return;

	// If the call wasn't for us, we chain on.
chain_on:
	_chain_intr(prev_int2f_handler);
}


/*
 * Fill in our UserData, upon unloading were are called back with this
 * information
 */

void prepare_for_tsr(uint32 drivelist)
{
	prev_int2f_handler=_dos_getvect(0x2f);
	UserData.prev_int2f_handler=(uint8 far *) prev_int2f_handler;
	UserData.our_int2f_handler=(uint8 far *) redirector;
	UserData.our_drive_list=drivelist;
	UserData.emsCompression=emsCompression;
	_dos_setvect(0x2f,redirector);
}


int unload_redir(signature_t far * sigrec)
{
	INTVECT 		p_vect;
	user_data_t		far *user_data=(user_data_t far *) sigrec->user_data;
	uint32			drivelist;
	int				i;


/*
 * give the running TSR a change to shutdown properly
 */
	_asm {
		mov	ah,0x11;
		mov al,_shutdown;
		int 2Fh;
	}

	p_vect=_dos_getvect(0x2f);

	/*
	 * Check that a subsequent TSR hasn't taken over Int 2Fh
	 */

	if (user_data->our_int2f_handler != (uint8 far *) p_vect)
	{
		tsr_print_string("Interrupt 2F has been superceded...",1);
		return 0;
	}

	/*
	 * Fix int2f chain
	 */

	p_vect=(INTVECT) user_data->prev_int2f_handler;
	_dos_setvect(0x2f,p_vect);


	drivelist=user_data->our_drive_list;
	for (i=0 ; i<26 ; i++)
	{
		if (drivelist & (2ul << i))
		{
			free_net_drive((uint8) i);
			our_drive_str[0]=(char) (i + 'A');
			tsr_print_string(our_drive_str, FALSE);
			tsr_print_string(" is now invalid.", TRUE);
		}
	}

		/*
		 * Free some Ems memory
		 */
	if (user_data->emsCompression)
		emsFreePages(user_data->emsCompression);
	if (!emskeep)
		debug_shutdown();
	return 1;
}

uint32 mount_drives()
{
	uint32	cmd, drivelist;
	uint8	rdrive;
	int		i;

	drivelist=0;
	for (i=0 ; i<26 ; i++)
	{
		if ((rdrive=MountTable[i]))
		{
			rdrive--;
			dprintf(D_ALWAYS, "Mounting remote disk %c: on %c:, waiting for server\r", rdrive+'A', i+'A');
			if (!is_local_free((uint8)i))
			{
				dprintf(D_ALWAYS, "Mounting remote disk %c: on %c:, failed (local drive is not available)\n", rdrive+'A', i+'A');
				continue;
			}

			cmd=MK_STD_CMD(0, 0, rdrive, 0);
			if (sys_mount(cmd, rdrive))
			{
				dprintf(D_ALWAYS, "Mounting remote disk %c: on %c:, failed (server could not mount %c:)\n", rdrive+'A', i+'A', rdrive+'A');
				continue;
			}

			dprintf(D_ALWAYS, "Mounting remote disk %c: on %c:, done                  \n", rdrive+'A', i+'A');
			make_net_drive((uint8) i);
			drivelist |= (2ul << i);		// mask bit
		}
	}
	return drivelist;
}

/* --------------------------------------------------------------------*/


int _cdecl main(uint16 argc , char **argv)
{
	int 	dout, dlevel, dpages, showdlist, unload, pport;
	uint32	drivelist=0;
	uint8	rdrive, ldrive;

	dlevel=showdlist=unload=pport=0;
	dpages=0;
	dout=DOUT_CONSOLE;
	memset(MountTable, 0, sizeof(MountTable));

	for (argv++; *argv; argv++)
	{
		switch (**argv)
		{
			case '-':
			case '/':
				(*argv)++;
				switch (toupper(**argv)) 
				{
					case '?':
						tsr_print_string(usage_string, TRUE);			
						return 0;
					case 'K':
						emskeep=1;
						break;
					case 'U':
						unload=1;
						break;
					case 'L':
						dlevel=simple_atoi((*argv)+1);
						break;
					case 'P':
						pport=simple_atoi((*argv)+1)-1;
						break;
					case 'C':
						(*argv)++;
						switch(toupper(**argv))
						{
							case 'S':
								use_compress=2;
								break;
							case 'O':
								use_compress=0;
								break;
						}
						break;
					case 'D':
						(*argv)++;
						switch(toupper(**argv))
						{
							case 'C':
								dout=DOUT_CONSOLE;
								break;
							case 'E':
								dout=DOUT_EMS;
								dpages=simple_atoi((*argv)+1);
								if (!dpages)
									dpages++;		// at least 1 page
								break;
							default:
								dout=DOUT_CONSOLE;
								dlevel=0;
								break;
						}
						break;
					case 'S':
						(*argv)++;
						switch(toupper(**argv))
						{
							case 'F':
								showdlist=1;
								break;
							default:
								tsr_print_string("Unrecognized parameter.", TRUE);
								return 0;
						}
						break;
					default:
						tsr_print_string("Unrecognized parameter.", TRUE);
						return 0;
				}
				break;
			default:
				if (strlen(*argv)!=3)
				{
					tsr_print_string("Unrecognized drive mapping.", TRUE);
					return 0;
				}
				ldrive=toupper(**argv) - 'A'; 
				rdrive=toupper(*(*argv+2)) - 'A'; 
				if (ldrive > 25 || rdrive > 25)
				{
					tsr_print_string("Invalid drive mapping .", TRUE);
					return 0;
				}
				MountTable[ldrive]=rdrive+1;

				break;
		}
	}

	if (unload)
	{
		get_dos_vars();
		tsr_unload_latest(TsrName, unload_redir);
		return 0;
	}

	tsr_print_string("RMOUNT v.",0);
	tsr_print_string(VersionString,1);

	if (showdlist)
	{
		debug_init(0, DOUT_CONSOLE, 0);
		debug_showlist();
		dprintf(D_ALWAYS, "\nUse binary | to combine debuglevels\n");
		return 0;
	}

	if ( (dout==DOUT_EMS || use_compress) && !emsPresent())
	{
		debug_init(0, DOUT_CONSOLE, 0);
		dprintf(D_ALWAYS, "Ems not present, bailing out\n");
		return 0;
	}

	if (!pp_initialize(pport))
	{
		debug_init(0, DOUT_CONSOLE, 0);
		dprintf(D_ALWAYS, "Could not initialise LPT%i, bailing out\n", pport+1);
		return 0;
	}
	
		/*
		 * Prepare debugging, but start logging to console to see
		 * any error messages
		 */
	debug_init(dlevel, dout, dpages);
	dout=debug_setout(DOUT_CONSOLE);

		/*
		 * Let's see if it's ok to install a new redirector
		 */
	if (!is_ok_to_load())
	{
		dprintf(D_ALWAYS, "Not OK to install a redirector, bailing out\n");
		return 0;
	}

		/*
		 * Allocate 64kb of ems for our compresssion buffer
		 */
	if (use_compress && !(emsCompression=emsAllocPages(4)))
	{
		dprintf(D_ALWAYS, "Could not allocate memory for compression buffer, bailing out\n");
		return 0;
	}
		/*
		 * Set up some global variables that point to
		 * dos internal data structures
		 */
	get_dos_vars();
	set_up_pointers();

		/*
		 * Mount the desired drives
		 */
	if ((drivelist=mount_drives())==0ul)
	{
		dprintf(D_ALWAYS, "There is nothing to mount, bailing out\n");
		return 0;
	}

	if (dout==DOUT_EMS)
		dprintf(D_SYSTEM, "Ems v%s: tot pages=%u, free=%u\n",emsGetVersion(),emsNumTotPages(),emsNumFreePages());

		/*
		 * Let's hit it Stan!
		 */
	debug_setout(dout);
	prepare_for_tsr(drivelist);			// sets UserData and chain int2f
	tsr_malloc(1);						// determine memory top
	tsr_go_resident(TsrName, &UserData);

		/*
		 * We're gone... never reached here
		 */

	return 0;
}




