#ifndef __SYSCALL_H
#define __SYSCALL_H

#include "rmount.h"
#include "systypes.h"

uint16 sys_mount(uint32 cmd, uint8 rdrive);
uint16 sys_chdir(uint32 cmd, char far* dirname);
uint16 sys_findfirst(uint32 cmd, char far* filespec, uint16 attr, DIRREC_PTR dirrec, SRCHREC_PTR srchrec);
uint16 sys_findnext(uint32 cmd, SRCHREC_PTR srchrec, DIRREC_PTR dirrec);
uint16 sys_mkdir(uint32 cmd, char far* dirname);
uint16 sys_rmdir(uint32 cmd, char far* dirname);
uint16 sys_getdiskspace(uint32 cmd, uint16* sec, uint16* clusters, uint16* bps, uint16* freeclus);
uint16 sys_delfile(uint32 cmd, char far* filename);
uint16 sys_renfile(uint32 cmd, char far* curfile, char far* newfile);
uint16 sys_setfileattr(uint32 cmd, char far* filename, unsigned attr);
uint16 sys_getfileattr(uint32 cmd, char far* filename, unsigned *attr);
uint16 sys_openfile(uint32 cmd, char far *filename, unsigned mode, unsigned* handle);
uint16 sys_special_openfile(uint32 cmd, char far *filename, unsigned attrib, unsigned open_mode, unsigned action, unsigned* result, unsigned* handle);
uint16 sys_createfile(uint32 cmd, char far *filename, unsigned attr, unsigned* handle);
uint16 sys_closefile(uint32 cmd, unsigned handle);
uint16 sys_commitfile(uint32 cmd, unsigned handle);
uint16 sys_readfile(uint32 cmd, unsigned handle, uint32 file_pos, unsigned size, char far *buffer, unsigned *nbytes);
uint16 sys_writefile(uint32 cmd, unsigned handle, uint32 file_pos, uint32 time, unsigned size, char far* buffer, unsigned *nbytes);

#endif		/* __SYSCALL_H */
