#pragma check_stack(off)
#include <dos.h>
#include <conio.h>

#include "debug.h"
#include "pport.h"


static unsigned Current_port;   /* address of last initialized port */
static unsigned rwMode;     	/* read write mode */

static unsigned char InputSync;     	/* read write mode */
static unsigned char OutputSync;     	/* read write mode */

#define MK_FP(a,b) ((void far *)(((unsigned long)(a) << 16) | (b)))
#define INPUT_SYNC_BIT  0x80  /* mask for input sync as read from port */
#define OUTPUT_SYNC_BIT 0x10

#define outportb(p,b) _outp(p,b)
#define inportb(p) _inp(p)

int pp_initialize(int port)      /* initialize port (arg is bios port 0-2) */
								 /* port 0 = LPT1, port 1 = LPT2, etc. */
{                                /* must be called before any i/o on the port */
	unsigned p;
	static unsigned int far *bios_ptr = (unsigned int far *) MK_FP(0x40, 8);

	if (port > 2 || port < 0)
		return 0;
	p = *(port + bios_ptr);
	if (p == 0)
		return 0;
	else
	{
		InputSync = INPUT_SYNC_BIT;
		OutputSync = OUTPUT_SYNC_BIT;
		outportb(p, 0);            /* initialize to zero output */
		Current_port = p;
		dprintf(D_SYSTEM, "Found LPT%i, using port:0x%x\n", port+1, p);
		return 1;
	}
}


void pp_send(unsigned char data)
{
	unsigned char 	byte;


	byte=(data & 0x0F) | OutputSync;
	outportb(Current_port, byte);
	OutputSync ^= OUTPUT_SYNC_BIT;

	do
	{
		byte=inportb(Current_port+1);
	} while(InputSync? (byte & INPUT_SYNC_BIT) : !(byte & INPUT_SYNC_BIT));

	InputSync ^= INPUT_SYNC_BIT;

	byte=((data & 0xF0) >> 4) | OutputSync;
	outportb(Current_port, byte);
	OutputSync ^= OUTPUT_SYNC_BIT;

	do
	{
		byte=inportb(Current_port+1);
	} while(InputSync? (byte & INPUT_SYNC_BIT) : !(byte & INPUT_SYNC_BIT));

	InputSync ^= INPUT_SYNC_BIT;

}

unsigned char pp_read()
{
	unsigned char 	byte, byte1;

	do
	{
		byte=inportb(Current_port+1);
	} while(InputSync? (byte & INPUT_SYNC_BIT) : !(byte & INPUT_SYNC_BIT));

	InputSync ^= INPUT_SYNC_BIT;

	byte1=inportb(Current_port+1);
	outportb(Current_port, OutputSync);
	OutputSync ^= OUTPUT_SYNC_BIT;

	do
	{
		byte=inportb(Current_port+1);
	} while(InputSync? (byte & INPUT_SYNC_BIT) : !(byte & INPUT_SYNC_BIT));

	InputSync ^= INPUT_SYNC_BIT;

	byte=inportb(Current_port+1);
	outportb(Current_port, OutputSync);
	OutputSync ^= OUTPUT_SYNC_BIT;
	return ( ((byte1 >> 3) & 0x0F) | ((byte << 1) & 0xF0));

}

void pp_switch_to_read()
{
	outportb(Current_port, OutputSync);
	OutputSync ^= OUTPUT_SYNC_BIT;
}

void pp_switch_to_write()
{
	unsigned char	byte;

	do
	{
		byte=inportb(Current_port+1);
	} while(InputSync? (byte & INPUT_SYNC_BIT) : !(byte & INPUT_SYNC_BIT));

	InputSync ^= INPUT_SYNC_BIT;

}
