#ifndef __TSR_H
#define __TSR_H

#include "systypes.h"

#define RUNNING_AS_TSR
#ifndef MK_FP
#define MK_FP(a,b)  ((void far *)(((uint32)(a) << 16) | (b)))
#endif

#define MAX_SIG 10
#define MAX_USR 12

#pragma pack(1)

/*
 * TSR signature and unload info structure
 */

typedef struct
{
		uint8       cmdline_len;
		char        signature[MAX_SIG];	/* The TSR's signature string */
		uint16      psp;            	/* This instance's PSP */
		char		user_data[MAX_USR]; /* Do with is as you please */
} signature_t;
#pragma pack()

typedef void (interrupt far* INTVECT)();
typedef int (unload_callbackfunc)(signature_t far *);


void* 	tsr_malloc(unsigned size);
void* 	tsr_calloc(unsigned items, unsigned item_size);
void  	tsr_print_string(char far *string, int newline);
void 	tsr_go_resident(char *signame, void *user_data);

void  	tsr_unload_latest(char *name, unload_callbackfunc f);

#endif		// __TSR_H

