#pragma check_stack(off)
#include <string.h>

#include "debug.h"
#include "pport.h"
#include "xdr.h"

int xdr_uint16(int how, uint16* i)
{
	uint8	*pc=(uint8 *) i;

	xdr_uint8(how, pc++);
	xdr_uint8(how, pc);

	return 1;
}

int xdr_uint8(int how, uint8 *pc)
{
	if (how==XDR_WRITE)
	{
		pp_send(*pc);
	}
	else
	{
		*pc=pp_read();
	}
	return 1;
}

int xdr_uint32(int how, uint32 *l)
{
	uint8	*pc=(uint8*) l;

	xdr_uint8(how, pc++);
	xdr_uint8(how, pc++);
	xdr_uint8(how, pc++);
	xdr_uint8(how, pc);

	return 1;
}

int xdr_filename(int how, char far *filename)
{
	uint16 len, i;

	if (how==XDR_WRITE)
	{
		len=_fstrlen(filename);
		xdr_uint16(XDR_WRITE, &len);
		for (i=0 ; i<len ; i++)
			pp_send(filename[i]);
	}
	else
	{
		xdr_uint16(XDR_READ, &len);
		for (i=0 ; i<len ; i++)
			filename[i]=pp_read();
		filename[len]=0;
	}

	return 1;
}

int xdr_data(int how, char far *data, uint16 *size)
{
	uint16		i;

	if (how==XDR_WRITE)
	{
		xdr_uint16(XDR_WRITE, size);
		for (i=0 ; i<*size ; i++)
			pp_send(data[i]);

	}
	else
	{
		xdr_uint16(XDR_READ, size);
		for (i=0 ; i<*size ; i++)
			data[i]=pp_read();
	}
	return 1;
}

int xdr_direntry(int how, char far *filename, uint32* size, uint8* attr, uint16* time, uint16* date)
{
	uint16		len=11;

	xdr_data(how, filename, &len);
	xdr_uint32(how, size);
	xdr_uint8(how, attr);
	xdr_uint16(how, time);
	xdr_uint16(how, date);

	return 1;
}

